// ************************************
// 
// V-SERVO TvvO2
// 
// sample2.c
// 
// V-SERVOʒuǂݍ
// 
// ************************************

#include <windows.h>
#include <stdio.h>
#include <math.h>


#define  COMPORT  "COM3"                                    // COM|[gݒ
#define  SID  0x00                                          // IDݒ

/* vg^Cv */
HANDLE CreateFile_port(LPCTSTR, DWORD, DWORD, LPSECURITY_ATTRIBUTES, DWORD, DWORD, HANDLE);
HANDLE serial_open(char *, DWORD, DWORD);
void serial_close(HANDLE);

/* C֐ */
int main(int argc, char *argv[])
{
  HANDLE hCom=(HANDLE)-1;
  int sid = SID;

  hCom = serial_open(COMPORT, CBR_115200, 10);
  if(hCom == (HANDLE)-1) {
    fprintf(stderr,"serial_open\n");
    exit(1);
  }

  while(hCom>=0) {
    BYTE buf[256];
    DWORD bytes;
    int cmd;

    // AbN
    buf[0] = 0x80 | SID;
    buf[1] = 0x40 | 0x00 | 1;                               // write 1byte
    buf[2] = 0x14;                                          // SYS_ULK
    buf[3] = 0x55;
    WriteFile(hCom, buf, 3+1, &bytes, NULL);

    // j[ʕ\
    printf("SID:%02x PORT:%s\n", SID, COMPORT);
    printf("  1 .. M_POSǂݍ݊Jn\n"
     "  9 .. I\n"
     ">");
    fflush(stdout);

    fgets(buf, 256, stdin);
    cmd = atoi(buf);
    switch(cmd) {

    // M_POSǂݍ
    case 1:
      while(!kbhit()){                                      //L[͂ȂΌJԂ
        buf[0] = 0x80 | SID;
        buf[1] = 0x00 | 0x20 | 2;                           // 2byteǂݍ
        buf[2] = 0x20;                                      // M_POS
        buf[3] = 0x00;                                      // Read̂߂̃_~[oCg
        buf[4] = 0x00;                                      // Read̂߂̃_~[oCg
        WriteFile(hCom, buf, 3+2, &bytes, NULL);
        ReadFile(hCom, buf, 2, &bytes, NULL);
        if(bytes == 0) {
          fprintf(stderr,"ǂݍ݃G[\n");
          break;
        }
        printf("    <%04x>    \n",((buf[1]<<7) + buf[0]) );
      }
      break;

    case 9:
      serial_close(hCom);
      exit(0);
      break;
    }
  }
  return 1;
}

/* VA֐ */
HANDLE CreateFile_port(LPCTSTR lpFileName,                  // pointer to name of the file
        DWORD dwDesiredAccess,                              // access (read-write) mode
        DWORD dwShareMode,                                  // share mode
        LPSECURITY_ATTRIBUTES lpSecurityAttributes,         // pointer to security attributes
        DWORD dwCreationDisposition,                        // how to create
        DWORD dwFlagsAndAttributes,                         // file attributes
        HANDLE hTemplateFile)                               //handle to file with attributes to copy
{
  char buf[1024];
  sprintf(buf, "\\\\.\\%s", lpFileName);
  return CreateFile(buf,
        dwDesiredAccess,                                    // access (read-write) mode
        dwShareMode,                                        // share mode
        lpSecurityAttributes,                               // pointer to security attributes
        dwCreationDisposition,                              // how to create
        dwFlagsAndAttributes,                               // file attributes
        hTemplateFile);                                     //handle to file with attributes to copy
}

HANDLE serial_open(char *portname, DWORD BaudRate, DWORD timeout)
{
  HANDLE hCom;
  DCB    stDcb;
  
  if((hCom = CreateFile_port(portname, GENERIC_READ | GENERIC_WRITE,
           0,                                               // exclusive access
           NULL,                                            // no security attrs
           OPEN_EXISTING,
           FILE_ATTRIBUTE_NORMAL |FILE_FLAG_WRITE_THROUGH,
           NULL)
      )==(HANDLE)-1) {
      fprintf(stderr,"cannot open");
    return (HANDLE)-1;
  }
    
  if(GetCommState(hCom,&stDcb)==FALSE){
      fprintf(stderr,"err in GetCommState()");
    return (HANDLE)-1;
  }
  stDcb.BaudRate=BaudRate;
  stDcb.fBinary=1;
  stDcb.fParity=0;
  stDcb.fOutxCtsFlow=0;
  stDcb.fOutxDsrFlow=0;
  stDcb.fDtrControl=DTR_CONTROL_HANDSHAKE;
  stDcb.fDsrSensitivity=0;
  stDcb.fTXContinueOnXoff=0;
  stDcb.fOutX=0;
  stDcb.fInX=0;
  stDcb.fErrorChar=0;
  stDcb.fNull=0;
  stDcb.fRtsControl=RTS_CONTROL_ENABLE;
  stDcb.fAbortOnError=0;
  stDcb.ByteSize=8;
  stDcb.Parity=NOPARITY;
  stDcb.StopBits=ONESTOPBIT;
  stDcb.EofChar=0;
  if(SetCommState(hCom,&stDcb)==FALSE){
      fprintf(stderr,"err in SetCommState()");
    CloseHandle(hCom);
    return (HANDLE)-1;
  }

  {
    COMMTIMEOUTS cto;
    cto.ReadIntervalTimeout         = timeout;              // msec 
    cto.ReadTotalTimeoutMultiplier  = timeout;              // msec 
    cto.ReadTotalTimeoutConstant    = timeout;              // msec 
    cto.WriteTotalTimeoutMultiplier = 0;                    // not used 
    cto.WriteTotalTimeoutConstant   = 0;                    // not used 
    
    if(SetCommTimeouts(hCom,&cto)==FALSE) {
      fprintf(stderr,"err in SetCommTimeouts()");
      CloseHandle(hCom);
      return (HANDLE)-1;
    }
  }
  
  return hCom;
}

void serial_close(HANDLE hCom)
{
  if(hCom && hCom!=(HANDLE)-1) {
    CloseHandle(hCom);
  }
}
