// ************************************
// 
// V-SERVO TvvO3
// 
// sample3.c
// 
// 
// tbVSID
// 
// ************************************

#include <windows.h>
#include <stdio.h>
#include <math.h>


#define  COMPORT  "COM3"                                    // COM|[gݒ
#define  SID  0x00                                          // IDݒ

/* vg^Cv */
HANDLE CreateFile_port(LPCTSTR, DWORD, DWORD, LPSECURITY_ATTRIBUTES, DWORD, DWORD, HANDLE);
HANDLE serial_open(char *, DWORD, DWORD);
void serial_close(HANDLE);

/* C֐ */
int main(int argc, char *argv[])
{
  HANDLE hCom=(HANDLE)-1;
  unsigned char psid = 0;
  unsigned char nsid = 0;


  while(1) {
    BYTE buf[256];
    DWORD bytes;
    int cmd;

    // j[ʕ\
    printf("SID:%02x VSID:%02x PORT:%s\n", psid, nsid, COMPORT);
    printf("  1 .. SIDݒ\n"
     "  2 .. VSIDݒ\n"
     "  3 .. tbVS\n"
     "  4 .. VSID\n"
     "  5 .. SIDǂݍ\n"
     "  9 .. I\n"
     ">");
    fflush(stdout);
    fgets(buf, 256, stdin);
    cmd = atoi(buf);

    switch(cmd) {

    // SIDZbg
    case 1:
      printf("PRESENT-SID:");
      fgets(buf,256,stdin);
      printf("\n");
      psid = atoi(buf);
      break;

    // VSIDZbg
    case 2:
      printf("NEW-SID:");
      fgets(buf,256,stdin);
      printf("\n");
      nsid = atoi(buf);
      break;

    // tbVNA
    case 3:
      hCom = serial_open(COMPORT, CBR_115200, 10);
      if(hCom == (HANDLE)-1) exit(1);                       // I[vłȂ̏

      buf[0] = 0x80 | psid;
      buf[1] = 0x00 | 0x00 | 2;                             // tbV2byte
      buf[2] = (0x00 & 0x7f);                               // SYS_PN̉7rbg
      buf[3] = (0x00 >> 7);                                 // SYS_PN̏7rbg
      buf[4] = (0x3e8 & 0x7f);                              // f[^7rbg
      buf[5] = (0x3e8 >> 7);                                // f[^7rbg
      buf[6] = ((-buf[2] -buf[3] -buf[4] -buf[5]) & 0x7f);  // `FbNT
      WriteFile(hCom, buf, 4+3, &bytes, NULL);

      printf("V-SERVO̓d؂āAċNĂ");
      fgets(buf,256,stdin);
      printf("\n");

      serial_close(hCom);

      break;

    // SIDXV(tbV)
    case 4:
      hCom = serial_open(COMPORT, CBR_115200, 10);
      if(hCom == (HANDLE)-1) exit(1);                       // I[vłȂ̏

      buf[0] = 0x80 | psid;
      buf[1] = 0x00 | 0x00 | 1;                             // tbV1byte
      buf[2] = (0x08 & 0x7f);                               // FB_SID̉7rbg
      buf[3] = (0x08 >> 7);                                 // FB_SID̏7rbg
      buf[4] = nsid;                                        // VSID
      buf[5] = (-buf[2] -buf[3] -buf[4]) & 0x7f;            // `FbNT
      WriteFile(hCom, buf, 4+2, &bytes, NULL);

      printf("V-SERVO̓d؂āAċNĂ");
      fgets(buf,256,stdin);
      printf("\n");

      serial_close(hCom);

      break;

    // ݂FB_ID\
    case 5:
      hCom = serial_open(COMPORT, CBR_115200, 10);
      if(hCom == (HANDLE)-1) exit(1);                       // I[vłȂ̏

      buf[0] = 0x80 | psid;
      buf[1] = 0x00 | 0x20 | 1;                             // ǂݍ1byte
      buf[2] = 0x08;                                        // FB_SID
      buf[3] = 0x00;                                        // ǂݍ݂̂߂̃_~[
      WriteFile(hCom, buf, 3+1, &bytes, NULL);
      ReadFile(hCom, buf, 1, &bytes, NULL);
      printf("FB_SID = %02x\n",buf[0]);

      serial_close(hCom);
      break;

    case 9:
      exit(0);
      break;
    }
  }
  return 1;
}

/* VA֐ */
HANDLE CreateFile_port(LPCTSTR lpFileName,                  // pointer to name of the file
        DWORD dwDesiredAccess,                              // access (read-write) mode
        DWORD dwShareMode,                                  // share mode
        LPSECURITY_ATTRIBUTES lpSecurityAttributes,         // pointer to security attributes
        DWORD dwCreationDisposition,                        // how to create
        DWORD dwFlagsAndAttributes,                         // file attributes
        HANDLE hTemplateFile)                               //handle to file with attributes to copy
{
  char buf[1024];
  sprintf(buf, "\\\\.\\%s", lpFileName);
  return CreateFile(buf,
        dwDesiredAccess,                                    // access (read-write) mode
        dwShareMode,                                        // share mode
        lpSecurityAttributes,                               // pointer to security attributes
        dwCreationDisposition,                              // how to create
        dwFlagsAndAttributes,                               // file attributes
        hTemplateFile);                                     //handle to file with attributes to copy
}
 

HANDLE serial_open(char *portname, DWORD BaudRate, DWORD timeout)
{
  HANDLE hCom;
  DCB    stDcb;
  
  if((hCom = CreateFile_port(portname, GENERIC_READ | GENERIC_WRITE,
           0,                                               // exclusive access
           NULL,                                            // no security attrs
           OPEN_EXISTING,
           FILE_ATTRIBUTE_NORMAL |FILE_FLAG_WRITE_THROUGH,
           NULL)
      )==(HANDLE)-1) {
      fprintf(stderr,"cannot open");
    return (HANDLE)-1;
  }
    
  if(GetCommState(hCom,&stDcb)==FALSE){
      fprintf(stderr,"err in GetCommState()");
    return (HANDLE)-1;
  }
  stDcb.BaudRate=BaudRate;
  stDcb.fBinary=1;
  stDcb.fParity=0;
  stDcb.fOutxCtsFlow=0;
  stDcb.fOutxDsrFlow=0;
  stDcb.fDtrControl=DTR_CONTROL_HANDSHAKE;
  stDcb.fDsrSensitivity=0;
  stDcb.fTXContinueOnXoff=0;
  stDcb.fOutX=0;
  stDcb.fInX=0;
  stDcb.fErrorChar=0;
  stDcb.fNull=0;
  stDcb.fRtsControl=RTS_CONTROL_ENABLE;
  stDcb.fAbortOnError=0;
  stDcb.ByteSize=8;
  stDcb.Parity=NOPARITY;
  stDcb.StopBits=ONESTOPBIT;
  stDcb.EofChar=0;
  if(SetCommState(hCom,&stDcb)==FALSE){
      fprintf(stderr,"err in SetCommState()");
    CloseHandle(hCom);
    return (HANDLE)-1;
  }

  {
    COMMTIMEOUTS cto;
    cto.ReadIntervalTimeout         = timeout;              // msec 
    cto.ReadTotalTimeoutMultiplier  = timeout;              // msec 
    cto.ReadTotalTimeoutConstant    = timeout;              // msec 
    cto.WriteTotalTimeoutMultiplier = 0;                    // not used 
    cto.WriteTotalTimeoutConstant   = 0;                    // not used 
    
    if(SetCommTimeouts(hCom,&cto)==FALSE) {
      fprintf(stderr,"err in SetCommTimeouts()");
      CloseHandle(hCom);
      return (HANDLE)-1;
    }
  }
  
  return hCom;
}

void serial_close(HANDLE hCom)
{
  if(hCom && hCom!=(HANDLE)-1) {
    CloseHandle(hCom);
  }
}

